Index: code/branches/questsystem5/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSLevel.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSLevel.cc	(revision 2908)
@@ -24,5 +24,4 @@
  *   Co-authors:
  *      Fabian 'x3n' Landau
- *      Benjamin Knecht
  *
  */
@@ -40,31 +39,22 @@
 #include "core/CommandLine.h"
 #include "core/ConfigValueIncludes.h"
+#include "core/CoreIncludes.h"
 #include "core/Core.h"
-#include "core/CoreIncludes.h"
-#include "core/Game.h"
-#include "core/GameMode.h"
 #include "objects/Tickable.h"
 #include "objects/Radar.h"
 #include "CameraManager.h"
-#include "GraphicsManager.h"
 #include "LevelManager.h"
 #include "PlayerManager.h"
-#include "orxonox/objects/quest/QuestManager.h"
-#include "orxonox/overlays/notifications/NotificationManager.h"
-#include "gui/GUIManager.h"
+#include "objects/quest/QuestManager.h"
+#include "overlays/notifications/NotificationManager.h"
 
 namespace orxonox
 {
-    AddGameState(GSLevel, "level");
-
-    SetCommandLineArgument(level, "presentation_dm.oxw").shortcut("l");
-    SetConsoleCommand(GSLevel, showIngameGUI, true);
-
-    GSLevel::GSLevel(const std::string& name)
-        : GameState(name)
-        , keyBinder_(0)
-        , gameInputState_(0)
-        , guiMouseOnlyInputState_(0)
-        , guiKeysOnlyInputState_(0)
+    SetCommandLineArgument(level, "presentation.oxw").shortcut("l");
+
+    GSLevel::GSLevel()
+//        : GameState<GSGraphics>(name)
+        : keyBinder_(0)
+        , inputState_(0)
         , radar_(0)
         , startFile_(0)
@@ -76,4 +66,6 @@
         this->ccKeybind_ = 0;
         this->ccTkeybind_ = 0;
+
+        setConfigValues();
     }
 
@@ -87,23 +79,16 @@
     }
 
-    void GSLevel::activate()
-    {
-        setConfigValues();
-
-        if (GameMode::showsGraphics())
-        {
-            gameInputState_ = InputManager::getInstance().createInputState<SimpleInputState>("game");
+    void GSLevel::enter(Ogre::Viewport* viewport)
+    {
+        if (Core::showsGraphics())
+        {
+            inputState_ = InputManager::getInstance().createInputState<SimpleInputState>("game", 20);
             keyBinder_ = new KeyBinder();
             keyBinder_->loadBindings("keybindings.ini");
-            gameInputState_->setHandler(keyBinder_);
-
-            guiMouseOnlyInputState_ = InputManager::getInstance().createInputState<SimpleInputState>("guiMouseOnly");
-            guiMouseOnlyInputState_->setMouseHandler(GUIManager::getInstancePtr());
-
-            guiKeysOnlyInputState_ = InputManager::getInstance().createInputState<SimpleInputState>("guiKeysOnly");
-            guiKeysOnlyInputState_->setKeyHandler(GUIManager::getInstancePtr());
+            inputState_->setHandler(keyBinder_);
 
             // create the global CameraManager
-            this->cameraManager_ = new CameraManager(GraphicsManager::getInstance().getViewport());
+            assert(viewport);
+            this->cameraManager_ = new CameraManager(viewport);
 
             // Start the Radar
@@ -117,5 +102,5 @@
         this->notificationManager_ = new NotificationManager();
 
-        if (GameMode::isMaster())
+        if (Core::isMaster())
         {
             // create the global LevelManager
@@ -125,6 +110,9 @@
         }
 
-        if (GameMode::showsGraphics())
-        {
+        if (Core::showsGraphics())
+        {
+            // TODO: insert slomo console command with
+            // .accessLevel(AccessLevel::Offline).defaultValue(0, 1.0).axisParamIndex(0).isAxisRelative(false);
+
             // keybind console command
             FunctorMember<GSLevel>* functor1 = createFunctor(&GSLevel::keybind);
@@ -144,21 +132,5 @@
     }
 
-    void GSLevel::showIngameGUI(bool show)
-    {
-        if (show)
-        {
-            GUIManager::getInstancePtr()->showGUI("inGameTest");
-            GUIManager::getInstancePtr()->executeCode("showCursor()");
-            InputManager::getInstance().requestEnterState("guiMouseOnly");
-        }
-        else
-        {
-            GUIManager::getInstancePtr()->executeCode("hideGUI(\"inGameTest\")");
-            GUIManager::getInstancePtr()->executeCode("hideCursor()");
-            InputManager::getInstance().requestLeaveState("guiMouseOnly");
-        }
-    }
-
-    void GSLevel::deactivate()
+    void GSLevel::leave()
     {
         // destroy console commands
@@ -173,5 +145,4 @@
             this->ccTkeybind_ = 0;
         }
-
 
         // this call will delete every BaseObject!
@@ -181,8 +152,8 @@
         //Loader::close();
 
-        if (GameMode::showsGraphics())
+        if (Core::showsGraphics())
             InputManager::getInstance().requestLeaveState("game");
 
-        if (GameMode::isMaster())
+        if (Core::isMaster())
             this->unloadLevel();
 
@@ -223,9 +194,7 @@
         }
 
-        if (GameMode::showsGraphics())
-        {
-            gameInputState_->setHandler(0);
-            guiMouseOnlyInputState_->setHandler(0);
-            guiKeysOnlyInputState_->setHandler(0);
+        if (Core::showsGraphics())
+        {
+            inputState_->setHandler(0);
             InputManager::getInstance().requestDestroyState("game");
             if (this->keyBinder_)
@@ -237,7 +206,7 @@
     }
 
-    void GSLevel::update(const Clock& time)
-    {
-        // Note: Temporarily moved to GSGraphics.
+    void GSLevel::ticked(const Clock& time)
+    {
+        // Commented by 1337: Temporarily moved to GSGraphics.
         //// Call the scene objects
         //for (ObjectList<Tickable>::iterator it = ObjectList<Tickable>::begin(); it; ++it)
@@ -282,9 +251,9 @@
         Command string that can be executed by the CommandExecutor
         OR: Internal string "KeybindBindingStringKeyName=" used for the second call to identify
-        the key/button/axis that has been activated. This is configured above in activate().
+        the key/button/axis that has been activated. This is configured above in enter().
     */
     void GSLevel::keybindInternal(const std::string& command, bool bTemporary)
     {
-        if (GameMode::showsGraphics())
+        if (Core::showsGraphics())
         {
             static std::string bindingString = "";
Index: code/branches/questsystem5/src/orxonox/gamestates/GSLevel.h
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSLevel.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSLevel.h	(revision 2908)
@@ -23,5 +23,5 @@
  *      Reto Grieder
  *   Co-authors:
- *      Benjamin Knecht
+ *      ...
  *
  */
@@ -31,23 +31,21 @@
 
 #include "OrxonoxPrereqs.h"
+#include <OgrePrerequisites.h>
 #include "core/OrxonoxClass.h"
-#include "core/GameState.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSLevel : public GameState, public OrxonoxClass
+    class _OrxonoxExport GSLevel : public OrxonoxClass
     {
+        friend class ClassIdentifier<GSLevel>;
     public:
-        GSLevel(const std::string& name);
+        GSLevel();
         ~GSLevel();
-        void setConfigValues();
-
-        void activate();
-        void deactivate();
-        void update(const Clock& time);
-
-        static void showIngameGUI(bool show);
 
     protected:
+        void enter(Ogre::Viewport* viewport);
+        void leave();
+        void ticked(const Clock& time);
+
         void loadLevel();
         void unloadLevel();
@@ -58,15 +56,13 @@
         void keybindInternal(const std::string& command, bool bTemporary);
 
-        KeyBinder*            keyBinder_;               //!< tool that loads and manages the input bindings
-        SimpleInputState*     gameInputState_;          //!< input state for normal ingame playing
-        SimpleInputState*     guiMouseOnlyInputState_;  //!< input state if we only need the mouse to use the GUI
-        SimpleInputState*     guiKeysOnlyInputState_;   //!< input state if we only need the keys to use the GUI
-        Radar*                radar_;                   //!< represents the Radar (not the HUD part)
-        XMLFile*              startFile_;               //!< current hard coded default level
-        CameraManager*        cameraManager_;           //!< camera manager for this level
-        LevelManager*         levelManager_;            //!< global level manager
-        PlayerManager*        playerManager_;           //!< player manager for this level
-        QuestManager*         questManager_;            //!< quest manager for this level
-        NotificationManager*  notificationManager_;     //!< notification manager for this level
+        KeyBinder*            keyBinder_;        //!< tool that loads and manages the input bindings
+        SimpleInputState*     inputState_;
+        Radar*                radar_;            //!< represents the Radar (not the HUD part)
+        XMLFile*              startFile_;        //!< current hard coded default level
+        CameraManager*        cameraManager_;
+        LevelManager*         levelManager_;
+        PlayerManager*        playerManager_;
+        QuestManager*          questManager_;
+        NotificationManager*  notificationManager_;
 
         //##### ConfigValues #####
@@ -76,4 +72,8 @@
         ConsoleCommand*       ccKeybind_;
         ConsoleCommand*       ccTkeybind_;
+
+    private:
+        void setConfigValues();
+
     };
 }
Index: code/branches/questsystem5/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSRoot.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSRoot.cc	(revision 2908)
@@ -32,29 +32,41 @@
 #include "util/Exception.h"
 #include "util/Debug.h"
-#include "core/Clock.h"
-#include "core/Game.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
+#include "core/Factory.h"
+#include "core/ConfigValueIncludes.h"
+#include "core/CoreIncludes.h"
+#include "core/ConsoleCommand.h"
 #include "core/CommandLine.h"
-#include "core/ConsoleCommand.h"
-#include "tools/TimeFactorListener.h"
+#include "core/Shell.h"
+#include "core/TclBind.h"
+#include "core/TclThreadManager.h"
+#include "core/LuaBind.h"
 #include "tools/Timer.h"
 #include "objects/Tickable.h"
 
+#ifdef ORXONOX_PLATFORM_WINDOWS
+#  ifndef WIN32_LEAN_AND_MEAN
+#    define WIN32_LEAN_AND_MEAN
+#  endif
+#  define NOMINMAX // required to stop windows.h screwing up std::min definition
+#  include "windows.h"
+#endif
+
 namespace orxonox
 {
-    AddGameState(GSRoot, "root");
-    SetCommandLineSwitch(console);
-    // Shortcuts for easy direct loading
-    SetCommandLineSwitch(server);
-    SetCommandLineSwitch(client);
-    SetCommandLineSwitch(dedicated);
-    SetCommandLineSwitch(standalone);
-
-    GSRoot::GSRoot(const std::string& name)
-        : GameState(name)
+    SetCommandLineArgument(limitToCPU, 1).information("0: off | #cpu");
+
+    GSRoot::GSRoot()
+        : RootGameState("root")
         , timeFactor_(1.0f)
         , bPaused_(false)
         , timeFactorPauseBackup_(1.0f)
-    {
+        , tclBind_(0)
+        , tclThreadManager_(0)
+        , shell_(0)
+    {
+        RegisterRootObject(GSRoot);
+        setConfigValues();
+
         this->ccSetTimeFactor_ = 0;
         this->ccPause_ = 0;
@@ -65,8 +77,59 @@
     }
 
-    void GSRoot::activate()
-    {
+    void GSRoot::setConfigValues()
+    {
+        SetConfigValue(statisticsRefreshCycle_, 250000)
+            .description("Sets the time in microseconds interval at which average fps, etc. get updated.");
+        SetConfigValue(statisticsAvgLength_, 1000000)
+            .description("Sets the time in microseconds interval at which average fps, etc. gets calculated.");
+    }
+
+    void GSRoot::enter()
+    {
+        // creates the class hierarchy for all classes with factories
+        Factory::createClassHierarchy();
+
         // reset game speed to normal
-        this->timeFactor_ = 1.0f;
+        timeFactor_ = 1.0f;
+
+        // reset frame counter
+        this->statisticsStartTime_ = 0;
+        this->statisticsTickTimes_.clear();
+        this->periodTickTime_ = 0;
+        this->avgFPS_ = 0.0f;
+        this->avgTickTime_ = 0.0f;
+
+        // Create the lua interface
+        this->luaBind_ = new LuaBind();
+
+        // initialise TCL
+        this->tclBind_ = new TclBind(Core::getMediaPathString());
+        this->tclThreadManager_ = new TclThreadManager(tclBind_->getTclInterpreter());
+
+        // create a shell
+        this->shell_ = new Shell();
+
+        // limit the main thread to the first core so that QueryPerformanceCounter doesn't jump
+        // do this after ogre has initialised. Somehow Ogre changes the settings again (not through
+        // the timer though).
+        int limitToCPU = CommandLine::getValue("limitToCPU");
+        if (limitToCPU > 0)
+            setThreadAffinity((unsigned int)(limitToCPU - 1));
+
+        {
+            // add console commands
+            FunctorMember<GSRoot>* functor = createFunctor(&GSRoot::exitGame);
+            functor->setObject(this);
+            this->ccExit_ = createConsoleCommand(functor, "exit");
+            CommandExecutor::addConsoleCommandShortcut(this->ccExit_);
+        }
+
+        {
+            // add console commands
+            FunctorMember01<GameStateBase, const std::string&>* functor = createFunctor(&GameStateBase::requestState);
+            functor->setObject(this);
+            this->ccSelectGameState_ = createConsoleCommand(functor, "selectGameState");
+            CommandExecutor::addConsoleCommandShortcut(this->ccSelectGameState_);
+        }
 
         {
@@ -85,38 +148,18 @@
             CommandExecutor::addConsoleCommandShortcut(this->ccPause_).accessLevel(AccessLevel::Offline);
         }
-
-        // Load level directly?
-        bool loadLevel = false;
-        if (CommandLine::getValue("standalone").getBool())
-        {
-            Game::getInstance().requestStates("graphics, standalone, level");
-            loadLevel = true;
-        }
-        if (CommandLine::getValue("server").getBool())
-        {
-            Game::getInstance().requestStates("graphics, server, level");
-            loadLevel = true;
-        }
-        if (CommandLine::getValue("client").getBool())
-        {
-            Game::getInstance().requestStates("graphics, client, level");
-            loadLevel = true;
-        }
-        if (CommandLine::getValue("dedicated").getBool())
-        {
-            Game::getInstance().requestStates("dedicated, level");
-            loadLevel = true;
-        }
-        
-        // Determine where to start otherwise
-        if (!loadLevel && !CommandLine::getValue("console").getBool())
-        {
-            // Also load graphics
-            Game::getInstance().requestState("graphics");
-        }
-    }
-
-    void GSRoot::deactivate()
-    {
+    }
+
+    void GSRoot::leave()
+    {
+        // destroy console commands
+        delete this->ccExit_;
+        delete this->ccSelectGameState_;
+
+        delete this->shell_;
+        delete this->tclThreadManager_;
+        delete this->tclBind_;
+
+        delete this->luaBind_;
+
         if (this->ccSetTimeFactor_)
         {
@@ -132,14 +175,9 @@
     }
 
-    void GSRoot::update(const Clock& time)
-    {
-        if (this->getActivity().topState)
-        {
-            // This state can not 'survive' on its own.
-            // Load a user interface therefore
-            Game::getInstance().requestState("ioConsole");
-        }
-
+    void GSRoot::ticked(const Clock& time)
+    {
         uint64_t timeBeforeTick = time.getRealMicroseconds();
+
+        TclThreadManager::getInstance().tick(time.getDeltaTime());
 
         for (ObjectList<TimerBase>::iterator it = ObjectList<TimerBase>::begin(); it; ++it)
@@ -160,6 +198,79 @@
         uint64_t timeAfterTick = time.getRealMicroseconds();
 
-        // Also add our tick time
-        Game::getInstance().addTickTime(timeAfterTick - timeBeforeTick);
+        // STATISTICS
+        assert(timeAfterTick - timeBeforeTick >= 0 );
+        statisticsTickInfo tickInfo = {timeAfterTick, timeAfterTick - timeBeforeTick};
+        statisticsTickTimes_.push_back(tickInfo);
+        assert(statisticsTickTimes_.back().tickLength==tickInfo.tickLength);
+        this->periodTickTime_ += tickInfo.tickLength;
+
+        // Ticks GSGraphics or GSDedicated
+        this->tickChild(time);
+
+        if (timeAfterTick > statisticsStartTime_ + statisticsRefreshCycle_)
+        {
+            std::list<statisticsTickInfo>::iterator it = this->statisticsTickTimes_.begin();
+            assert(it != this->statisticsTickTimes_.end());
+            int64_t lastTime = timeAfterTick - statisticsAvgLength_;
+            if ((int64_t)it->tickTime < lastTime)
+            {
+                do
+                {
+                    assert(this->periodTickTime_ > it->tickLength);
+                    this->periodTickTime_ -= it->tickLength;
+                    ++it;
+                    assert(it != this->statisticsTickTimes_.end());
+                } while ((int64_t)it->tickTime < lastTime);
+                this->statisticsTickTimes_.erase(this->statisticsTickTimes_.begin(), it);
+            }
+
+            uint32_t framesPerPeriod = this->statisticsTickTimes_.size();
+            this->avgFPS_ = (float)framesPerPeriod / (timeAfterTick - this->statisticsTickTimes_.front().tickTime) * 1000000.0;
+            this->avgTickTime_ = (float)this->periodTickTime_ / framesPerPeriod / 1000.0;
+
+            statisticsStartTime_ = timeAfterTick;
+        }
+
+    }
+
+    /**
+    @note
+        The code of this function has been copied and adjusted from OGRE, an open source graphics engine.
+            (Object-oriented Graphics Rendering Engine)
+        For the latest info, see http://www.ogre3d.org/
+
+        Copyright (c) 2000-2008 Torus Knot Software Ltd
+
+        OGRE is licensed under the LGPL. For more info, see OGRE license.
+    */
+    void GSRoot::setThreadAffinity(unsigned int limitToCPU)
+    {
+#ifdef ORXONOX_PLATFORM_WINDOWS
+        // Get the current process core mask
+        DWORD procMask;
+        DWORD sysMask;
+#  if _MSC_VER >= 1400 && defined (_M_X64)
+        GetProcessAffinityMask(GetCurrentProcess(), (PDWORD_PTR)&procMask, (PDWORD_PTR)&sysMask);
+#  else
+        GetProcessAffinityMask(GetCurrentProcess(), &procMask, &sysMask);
+#  endif
+
+        // If procMask is 0, consider there is only one core available
+        // (using 0 as procMask will cause an infinite loop below)
+        if (procMask == 0)
+            procMask = 1;
+
+        // if the core specified with limitToCPU is not available, take the lowest one
+        if (!(procMask & (1 << limitToCPU)))
+            limitToCPU = 0;
+
+        // Find the lowest core that this process uses and limitToCPU suggests
+        DWORD threadMask = 1;
+        while ((threadMask & procMask) == 0 || (threadMask < (1u << limitToCPU)))
+            threadMask <<= 1;
+
+        // Set affinity to the first core
+        SetThreadAffinityMask(GetCurrentThread(), threadMask);
+#endif
     }
 
@@ -170,5 +281,5 @@
     void GSRoot::setTimeFactor(float factor)
     {
-        if (GameMode::isMaster())
+        if (Core::isMaster())
         {
             if (!this->bPaused_)
@@ -188,5 +299,5 @@
     void GSRoot::pause()
     {
-        if (GameMode::isMaster())
+        if (Core::isMaster())
         {
             if (!this->bPaused_)
@@ -203,3 +314,13 @@
         }
     }
+
+    ////////////////////////
+    // TimeFactorListener //
+    ////////////////////////
+    float TimeFactorListener::timefactor_s = 1.0f;
+
+    TimeFactorListener::TimeFactorListener()
+    {
+        RegisterRootObject(TimeFactorListener);
+    }
 }
Index: code/branches/questsystem5/src/orxonox/gamestates/GSRoot.h
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSRoot.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSRoot.h	(revision 2908)
@@ -31,18 +31,29 @@
 
 #include "OrxonoxPrereqs.h"
-#include "core/GameState.h"
+
+#include <list>
+#include <OgreLog.h>
+#include "core/RootGameState.h"
 #include "core/OrxonoxClass.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSRoot : public GameState
+    class _OrxonoxExport GSRoot : public RootGameState, public OrxonoxClass
     {
+        friend class ClassIdentifier<GSRoot>;
+
     public:
-        GSRoot(const std::string& name);
+        struct statisticsTickInfo
+        {
+            uint64_t    tickTime;
+            uint32_t    tickLength;
+        };
+    
+    public:
+        GSRoot();
         ~GSRoot();
 
-        void activate();
-        void deactivate();
-        void update(const Clock& time);
+        void exitGame()
+        { requestState("root"); }
 
         // this has to be public because proteced triggers a bug in msvc
@@ -52,12 +63,61 @@
         float getTimeFactor() { return this->timeFactor_; }
 
+        float getAvgTickTime() { return this->avgTickTime_; }
+        float getAvgFPS()      { return this->avgFPS_; }
+
+        inline void addTickTime(uint32_t length)
+            { assert(!this->statisticsTickTimes_.empty()); this->statisticsTickTimes_.back().tickLength += length;
+              this->periodTickTime_+=length; }
+
     private:
+        void enter();
+        void leave();
+        void ticked(const Clock& time);
+
+        void setConfigValues();
+        void setThreadAffinity(unsigned int limitToCPU);
+
         float                 timeFactor_;       //!< A factor that sets the gamespeed. 1 is normal.
         bool                  bPaused_;
         float                 timeFactorPauseBackup_;
+        TclBind*              tclBind_;
+        TclThreadManager*     tclThreadManager_;
+        Shell*                shell_;
+        LuaBind*              luaBind_;
+
+        // variables for time statistics
+        uint64_t              statisticsStartTime_;
+        std::list<statisticsTickInfo>
+                              statisticsTickTimes_;
+        uint32_t              periodTickTime_;
+        float                 avgFPS_;
+        float                 avgTickTime_;
+
+        // config values
+        unsigned int          statisticsRefreshCycle_;
+        unsigned int          statisticsAvgLength_;
 
         // console commands
+        ConsoleCommand*       ccExit_;
+        ConsoleCommand*       ccSelectGameState_;
         ConsoleCommand*       ccSetTimeFactor_;
         ConsoleCommand*       ccPause_;
+    };
+
+    class _OrxonoxExport TimeFactorListener : virtual public OrxonoxClass
+    {
+        friend class GSRoot;
+
+        public:
+            TimeFactorListener();
+            virtual ~TimeFactorListener() {}
+
+        protected:
+            virtual void changedTimeFactor(float factor_new, float factor_old) {}
+            inline float getTimeFactor() const
+                { return TimeFactorListener::timefactor_s; }
+
+        private:
+            static float timefactor_s;
     };
 }
Index: code/branches/questsystem5/src/orxonox/gamestates/GSServer.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSServer.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSServer.cc	(revision 2908)
@@ -31,16 +31,13 @@
 
 #include "core/CommandLine.h"
-#include "core/Game.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "network/Server.h"
 
 namespace orxonox
 {
-    AddGameState(GSServer, "server");
-
     SetCommandLineArgument(port, 55556).shortcut("p").information("0-65535");
 
-    GSServer::GSServer(const std::string& name)
-        : GameState(name)
+    GSServer::GSServer()
+        : GameState<GSGraphics>("server")
         , server_(0)
     {
@@ -51,25 +48,31 @@
     }
 
-    void GSServer::activate()
+    void GSServer::enter()
     {
-        GameMode::setHasServer(true);
+        Core::setHasServer(true);
 
         this->server_ = new Server(CommandLine::getValue("port"));
         COUT(0) << "Loading scene in server mode" << std::endl;
 
+        GSLevel::enter(this->getParent()->getViewport());
+
         server_->open();
     }
 
-    void GSServer::deactivate()
+    void GSServer::leave()
     {
+        GSLevel::leave();
+
         this->server_->close();
         delete this->server_;
 
-        GameMode::setHasServer(false);
+        Core::setHasServer(false);
     }
 
-    void GSServer::update(const Clock& time)
+    void GSServer::ticked(const Clock& time)
     {
-        server_->update(time);
+        GSLevel::ticked(time);
+        server_->tick(time.getDeltaTime());
+        this->tickChild(time);
     }
 }
Index: code/branches/questsystem5/src/orxonox/gamestates/GSServer.h
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSServer.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSServer.h	(revision 2908)
@@ -31,21 +31,22 @@
 
 #include "OrxonoxPrereqs.h"
-#include "core/GameState.h"
 #include "network/NetworkPrereqs.h"
+#include "GSLevel.h"
+#include "GSGraphics.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSServer : public GameState
+    class _OrxonoxExport GSServer : public GameState<GSGraphics>, public GSLevel
     {
     public:
-        GSServer(const std::string& name);
+        GSServer();
         ~GSServer();
 
-        void activate();
-        void deactivate();
-        void update(const Clock& time);
+    private:
+        void enter();
+        void leave();
+        void ticked(const Clock& time);
 
-    private:
-        Server* server_;
+        Server*      server_;
     };
 }
Index: code/branches/questsystem5/src/orxonox/gamestates/GSStandalone.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSStandalone.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSStandalone.cc	(revision 2908)
@@ -30,18 +30,10 @@
 #include "GSStandalone.h"
 
-#include <OgreViewport.h>
-#include <OgreCamera.h>
-#include "core/Game.h"
-#include "core/GameMode.h"
-#include "core/ConsoleCommand.h"
-#include "gui/GUIManager.h"
-#include "GraphicsManager.h"
+#include "core/Core.h"
 
 namespace orxonox
 {
-    AddGameState(GSStandalone, "standalone");
-
-    GSStandalone::GSStandalone(const std::string& name)
-        : GameState(name)
+    GSStandalone::GSStandalone()
+        : GameState<GSGraphics>("standalone")
     {
     }
@@ -51,17 +43,22 @@
     }
 
+    void GSStandalone::enter()
+    {
+        Core::setIsStandalone(true);
 
-    void GSStandalone::activate()
-    {
-        GameMode::setIsStandalone(true);
+        GSLevel::enter(this->getParent()->getViewport());
     }
 
-    void GSStandalone::deactivate()
+    void GSStandalone::leave()
     {
-        GameMode::setIsStandalone(false);
+        GSLevel::leave();
+
+        Core::setIsStandalone(false);
     }
 
-    void GSStandalone::update(const Clock& time)
+    void GSStandalone::ticked(const Clock& time)
     {
+        GSLevel::ticked(time);
+        this->tickChild(time);
     }
 }
Index: code/branches/questsystem5/src/orxonox/gamestates/GSStandalone.h
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSStandalone.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSStandalone.h	(revision 2908)
@@ -31,19 +31,19 @@
 
 #include "OrxonoxPrereqs.h"
-#include "core/GameState.h"
+#include "GSLevel.h"
+#include "GSGraphics.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSStandalone : public GameState
+    class _OrxonoxExport GSStandalone : public GameState<GSGraphics>, public GSLevel
     {
     public:
-        GSStandalone(const std::string& name);
+        GSStandalone();
         ~GSStandalone();
 
-        void activate();
-        void deactivate();
-        void update(const Clock& time);
-
     private:
+        void enter();
+        void leave();
+        void ticked(const Clock& time);
     };
 }
